<html>
<head>
  <meta http-equiv='content-type' content='text/html; charset=UTF-8'>
  <title>HP Insight Diagnostics</title>
  <link rel='stylesheet' type='text/css' href='stylesheets/main.css'>
  <SCRIPT LANGUAGE='JavaScript' SRC='menufunctions.js'>
  </SCRIPT>
</head>
<?php
@session_start();

   /***********************************************************************
   *    Copyright  2002 - 2005 Hewlett-Packard Development Company, L.P. *
   ***********************************************************************/


$_SESSION["testPage"] = "customframe.php";
//include "iocommand.php";
include "fefunctions.php";

$test = 0;
$test = $_REQUEST["send"];

if ($HTTP_POST_VARS["send"] == "1")  
{
  $stopOnError = $HTTP_POST_VARS["stopOnError"];
  $runMode = $HTTP_POST_VARS["runMode"];

  if ($runMode == "time")
    $mode = $HTTP_POST_VARS["totalTestTime"];
  else
    $mode = $HTTP_POST_VARS["testLoops"];

  $dom = domxml_new_doc("1.0");
  $startProcess = $dom->create_element("startProcess");
  $diagRun = $dom->create_element("diagRun");

  $diagRun->set_attribute("jobCaption", htmlentities(TR("MSG_CUSTOM_TEST"),ENT_QUOTES,'utf-8'));

  if ($runMode == "time")
    $diagRun->set_attribute("desiredTestTime", $mode);
  else
    $diagRun->set_attribute("testLoops", $mode);

  if ($stopOnError == "on")
    $diagRun->set_attribute("stopOnError", "1");

  $diagRun->set_attribute("language", GetLanguage());        

  while(list($key, $value) = each($HTTP_POST_VARS))
  {	  
    if(strstr($key, "-")) // MUST be careful about this - Enforce tests to not contain the - character !
    {
      $idXml = new DomDocument($_SESSION["idResult"]);
      $idXpath = xpath_new_context($idXml->document_element());
	    $deviceStr = substr($key, 0, strpos($key, "-")); // get the device
	    $testStr = substr($key,strpos($key, "-")+1); // get the test
      $tests = xpath_eval($idXpath, "/diagOutput/category/device[@name='".$deviceStr."']/test[@name='".$testStr."']");
	    $testNode = $tests->nodeset[0];

	    $device = $testNode->parent_node();
      $testName = $testNode->get_attribute("name");
	    $testDescription = $testNode->get_attribute("description");
	    $testCaption = $testNode->get_attribute("caption");
	    $deviceCaption = $device->get_attribute("caption");
      $componentName = $device->get_attribute("component");
      $deviceSlot = $device->get_attribute("Slot");
	    $deviceName = $device->get_attribute("name");

	    $runTest = $dom->create_element("runTest");
	    // get the posted parameters that were saved earlier
	    $formDatas = xpath_eval($idXpath, "/diagOutput/category/device[@name='".$deviceStr."']/test[@name='".$testStr."']/formData");
	    if (count($formDatas->nodeset))
	    {
	      $formData = $formDatas->nodeset[0];
	  	  $attributesArr = $formData->attributes();

        for( $j=0; $j < count($attributesArr); $j++)
        {
		      if ($attributesArr[$j]->get_content() == "on")
            $runTest->set_attribute($attributesArr[$j]->node_name(), "1");
          else if ($attributesArr[$j]->get_content() == "off")
            $runTest->set_attribute($attributesArr[$j]->node_name(), "0");
          else
		        $runTest->set_attribute($attributesArr[$j]->node_name(), $attributesArr[$j]->get_content());
        }
	    }
	    $runTest->set_attribute("component", $componentName);
	    $tcLoadFilename = $componentName . ".dat";
	    $runTest->set_attribute("tcLoadFilename", $tcLoadFilename);
	    $runTest->set_attribute("language", GetLanguage());
      $runTest->set_attribute("device", $deviceName);
      $runTest->set_attribute("test", $testName);
      if ($testNode->get_attribute("interactive") == "1" && $_SESSION["testMode"] == "interactive")
        $runTest->set_attribute("interactive", "1");
      if ($deviceSlot != "")
        $runTest->set_attribute("Slot", $deviceSlot); // slot the ctrlr is in that the device is attached to
      $runTest->set_attribute("description", htmlentities($testDescription,ENT_QUOTES,'utf-8'));
	    $runTest->set_attribute("caption", htmlentities($deviceCaption . " - " . $testCaption,ENT_QUOTES,'utf-8'));
      if ($testNode->get_attribute("singleThread") == "1")
        $runTest->set_attribute("singleThread", "1");
      if ($testNode->get_attribute("interactive") == "1" && $_SESSION["testMode"] == "interactive")
        $runTest->set_attribute("interactive", "1");
      $runTest->set_attribute("complete", "1");

      $diagRun->append_child($runTest);
	  }
  }

  $scheduleMode = $HTTP_POST_VARS["scheduleType"];
  
  if ($scheduleMode == "diagRun") // if we want to schedule this test
  { 
    $scheduleProcess = $dom->create_element("scheduleProcess");
    $scheduleProcess->set_attribute("hour", $HTTP_POST_VARS["scheduleHour"]);
    $scheduleProcess->set_attribute("minute", $HTTP_POST_VARS["scheduleMinute"]);
    $scheduleProcess->set_attribute("mode", $HTTP_POST_VARS["scheduleMode"]);
    $scheduleProcess->set_attribute("weekdays", $HTTP_POST_VARS["scheduleWeekdays"]);
    $scheduleProcess->set_attribute("months", $HTTP_POST_VARS["scheduleMonths"]);
    $scheduleProcess->set_attribute("monthdays",$HTTP_POST_VARS["scheduleMonthdays"]);
    $scheduleProcess->append_child($diagRun);
    $dom->append_child($scheduleProcess);
  }
  else // otherwise, run now
  {
    $startProcess->append_child($diagRun);
    $dom->append_child($startProcess);
  }

  // debug
  //echo htmlentities($dom->html_dump_mem());
    
  // Submit the diagRun command					  
  $runErrors = "";
  $runStatus = "";
  if (GetLanguage() == "ja")
    $diagRunStr = sprintf("%s", $dom->dump_mem(true, "UTF-8"));
  else
    $diagRunStr = sprintf("%s", $dom->dump_mem());
  $_SESSION["diagRun"] = $diagRunStr;
  ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $diagRunStr, $runStatus, $runErrors);
  $xmldoc = new DomDocument($runStatus);
  
  $_SESSION["statusxml"] = "";
  $_SESSION["lastTest"] = 99;
  $_SESSION["lastPrompt"] = "";
  $_SESSION["statusDrawn"] = "false";
  unset($_SESSION["completedTests"]);
  $_SESSION["lastLoop"] = "";

  $rootElement = $xmldoc->document_element();
  $_SESSION["testpid"] = $rootElement->get_attribute("processID");
  
  if ($scheduleMode != "diagRun") // if we did not schedule this test
  {
    // GO TO STATUS PAGE NOW...
    printf("<script language=\"JavaScript\">\n");
    if (IsDiagsCD() || IsPhoenix())
    {
      //remove the refresh button - it will lock up if we try to refresh whne testing
      printf("  parent.parent.frames.headerFrame.document.getElementById('refresh').style.visibility = 'hidden';\n");
      printf("  parent.parent.frames.headerFrame.document.getElementById('refresh').style.display = 'none';\n");
    }
    printf("parent.parent.frames.headerFrame.scheduledTest = '';");
    printf("parent.parent.frames.headerFrame.doTab(2);\n");
    printf("parent.parent.frames.menuFrame.location = 'statusmenu.php';");
    printf("</script>\n");
  }
  else
  {
    // GO TO STATUS PAGE NOW...
    printf("<script language=\"JavaScript\">\n");
    printf("parent.parent.frames.headerFrame.scheduledTest = 'custom';\n");
    printf("location = 'customtest.php';");
    printf("</script>\n");
  }
}
else
{
?>
<body onload="growTrees(parent.parent.frames.headerFrame.testTree,parent.parent.frames.headerFrame.testsSelected);">
<form name="diagRunForm" method=POST>

<script language=Javascript>
 function swap(objct, image,treeIndex) //swaps tree images from x to -
 {
   if(document.getElementById(objct).style.visibility == 'visible')
   {
     document.getElementById(objct).style.display = 'none';
     document.getElementById(objct).style.visibility = 'hidden';
     document.images[image].src = 'littlex.gif';
     parent.parent.frames.headerFrame.testTree[treeIndex] = "hidden";
   }
   else
   {
     document.getElementById(objct).style.display = 'inline';
     document.getElementById(objct).style.visibility = 'visible';
     document.images[image].src = 'littledash.gif';
	   parent.parent.frames.headerFrame.testTree[treeIndex] = 'visible';
   }
 }

 function checkDeviceTests(dev, numTests, menuIndex)
 {
   hideScheduledMessage();
   swap('menu'+menuIndex,'image'+menuIndex, menuIndex);

   for(element=0; element <= numTests; element++)
   {
     document.diagRunForm.elements[dev+element].checked=document.diagRunForm.elements[dev+0].checked;
     // set the array that keeps track of the tests that are selected/deselected 
     if (parent.parent.frames.headerFrame.testsSelected[dev+element] == "true")
       parent.parent.frames.headerFrame.testsSelected[dev+element] = "";
     else
       parent.parent.frames.headerFrame.testsSelected[dev+element] = "true";
   }    
 }

 function getParameters(device, test, elroy)
 {
   hideScheduledMessage();

   // set the array that keeps track of the tests that are selected/deselected 
   if (parent.parent.frames.headerFrame.testsSelected[elroy] == "true")
     parent.parent.frames.headerFrame.testsSelected[elroy] = "";
   else
     parent.parent.frames.headerFrame.testsSelected[elroy] = "true";

   // now get the parameters
   document.diagRunForm.device.value = device;
   document.diagRunForm.test.value = test;
   parent.parent.frames.dataFrame.frames.parmFrame.document.parametersForm.submit();
 }

function checkAll()
{
  hideScheduledMessage();

  for (var i = 0; i < document.diagRunForm.elements.length; i++)
  {
    if (document.diagRunForm.elements[i].type == 'checkbox' && document.diagRunForm.elements[i].name != 'stopOnError')
      document.diagRunForm.elements[i].checked = true;

    // update the array that keeps track of the selected tests
	  parent.parent.frames.headerFrame.testsSelected[i] = 'true';
  }
}

function uncheckAll()
{
  hideScheduledMessage();

  for (var i = 0; i < document.diagRunForm.elements.length; i++)
  {
    if (document.diagRunForm.elements[i].type == 'checkbox' && document.diagRunForm.elements[i].name != 'stopOnError')
      document.diagRunForm.elements[i].checked = false;

    // update the array that keeps track of the selected tests
	  parent.parent.frames.headerFrame.testsSelected[i] = '';
  }
}


function validate(parameter)
{
  var val = new Number(parameter);
  if(val != parameter)
  {
    alert('<?php echo TR('MSG_NUMERIC_ONLY'); ?>');
    return false;
  }
  else if(val <= 0)
  {
    alert('<?php echo TR('MSG_NUMERIC_ONLY'); ?>' +' > 0');
    return false;
  }
  
  return true;
}

/*******************************************************************************************************
* This fuction submits the parameter page and then after the parameter page is submitted the parameter *
* page will call the BeginTesting function on the customtest page.  This has to be done this way or we *
* will lock up due to the fact that both pages have to access the idResult session variable.		       *
*******************************************************************************************************/
function SubmitParametersFirst()
{
  parent.parent.frames.dataFrame.frames.parmFrame.document.parametersForm.begin.value='1';
  parent.parent.frames.dataFrame.frames.parmFrame.document.parametersForm.submit();
}

</script>
<table>
<tr valign=top><td class='head'>
<?php 
echo TR("MSG_CUSTOM_TEST");
printf("</td><td id='hasBeenScheduledMessage'  style='visiblity:hidden; display:none'>   <font color='blue'>*</font> This custom test has been scheduled");
?></td></tr>
</table><hr>
<!-------- Buttons -------->
<table>
<tr><td><?php echo TR('MSG_CUSTOM_TEST_INSTRUCTIONS');
echo "<br>" . TR('MSG_SELECT_ALL_INSTRUCTIONS');
if (IsOnline())
  printf("<br>%s<br>  <a href='#' onclick='window.open(\"schedule.php?schedule=diagRun\", \"scedule\", \"width=400,height=500,dependent=yes,directories=no,hotkeys=no,location=no,menubar=no,resizeable=no,status=no,toolbar=no,alwaysRaised=yes\");'>%s</a>", TR("MSG_TEST_SCHEDULE_INSTRUCTION"), TR("Click here to schedule this test"));


?>
</td></tr>
</table>
<table>
<tr><td><input type=radio name='runMode' value='loops' checked> <?php echo TR("MSG_NUMBER_OF_LOOPS"); ?>:</td><td><input type=text name='testLoops' size=3 value='1' maxlength=4  onchange='if(!validate(this.value))this.value="1";'></td></tr>
<tr><td><input type=radio name='runMode' value='time'><?php echo TR("MSG_TOTAL_TEST_TIME"); ?>:</td><td><input type=text  name='totalTestTime' maxlength=4 size=3 value='' onchange='if(!validate(this.value))this.value="1";'></td></tr>
<tr><td><input type='checkbox' name='stopOnError' onclick="if(this.checked) parent.parent.frames.headerFrame.testsSelected[4]='true';else parent.parent.frames.headerFrame.testsSelected[4]='';" ><?php echo TR("MSG_STOP_ON_FIRST_ERROR"); ?></td></tr>
<tr><td><?php 
if ($_SESSION["testpid"] == "")
  echo MakeButton(TR("MSG_BEGIN_TESTING"), "SubmitParametersFirst();");
else
  echo MakeButton(TR("MSG_BEGIN_TESTING"), "alert('".TR("MSG_TESTING_IN_PROGRESS") . ". " . TR("MSG_PLEASE_WAIT_FOR_TESTS").".');");
?></td>
<td><?php echo MakeButton(TR("MSG_EXPAND"), "expand_Collapse()", "expand_collapse"); ?></td></tr>
<tr><td><?php echo MakeButton(TR("MSG_CHECK_ALL"), "checkAll()"); ?></td>
<td><?php echo MakeButton(TR("MSG_UNCHECK_ALL"), "uncheckAll()"); ?></td></tr>
</table>
<!----- End Buttons ------>



<?php
if (IsPhoenix())
  printf("<div style='height:400px;overflow:auto'>\n");
else
  printf("<div style='height:290px;overflow:auto'>\n");
?>
<table>
  <tr>
    <td colspan=3 nowrap>
<?php

//echo "ADVANCED = " . $_SESSION["advanced"];

 // parent.parent.frames.dataFrame.frames.parmFrame.document.parametersForm.submit(); 

  $idXml = new DomDocument($_SESSION["idResult"]);
  $idXpath = @xpath_new_context($idXml->document_element());
  $categories = @xpath_eval($idXpath, "/diagOutput/category");
  $element = 5; // need to keep track of the number of elements on the page - starts at 5 b/c of the test mode fields
  $menuIndex = 0; // need to keep track of menu number

  $testFilter = "[@fieldtest='1'";
  if (IsFactory())
    $testFilter = $testFilter . " or @fieldtest='0'";

  if ($_SESSION["testMode"] == "unattended")
    $testFilter = $testFilter . " and @interactive='0'";
  if (!$_SESSION["advanced"])
    $testFilter = $testFilter . " and @destructive='0'";
  $testFilter = $testFilter . "]";


  $num_categories = count($categories->nodeset);
  for ($i=0; $i < $num_categories; $i++)
  {
    $categoryNode = $categories->nodeset[$i];
    $categoryXpath = xpath_new_context($categoryNode);
    $devices = xpath_eval($categoryXpath, "/device");	
    $num_devices = count($devices->nodeset);
	  if ($num_devices)
	  {
      $catPrint = 0;
      $categoryName = $categoryNode->get_attribute("name");
      $categoryCaption = $categoryNode->get_attribute("caption");
      $categoryDescription = $categoryNode->get_attribute("description");
    	
      // do this with a sprintf b/c we do not know if we really want to display it yet b/c we don't know if we have tests to display
      // based on the testFilter
      $oss = sprintf("      <span onclick=swap('menu%d','image%d',%d);>\n", $menuIndex, $menuIndex, $menuIndex);
      $oss = $oss . sprintf("        <img src='littlex.gif' name='image%d'>&nbsp;%s\n", $menuIndex, $categoryCaption);
      $oss = $oss . sprintf("      </span>\n      <br>\n");
      $oss = $oss . sprintf("      <div id='menu%d' style='Visibility:hidden; display:none;'>\n", $menuIndex);

      for ($j=0; $j < $num_devices; $j++)
      {
        $deviceNode = $devices->nodeset[$j];
	      $deviceXpath = @xpath_new_context($deviceNode);
        $deviceName = $deviceNode->get_attribute("name");
        $deviceCaption = $deviceNode->get_attribute("caption");
        $deviceDescription = $deviceNode->get_attribute("description");

	      $tests = @xpath_eval($deviceXpath, "/test".$testFilter);
        $num_tests = count($tests->nodeset);
        
        $listWithoutTests = $deviceNode->get_attribute("listWithoutTests");
        if ($listWithoutTests == "1")
        {
          $lWOTcaption = $deviceNode->get_attribute("listWithoutTestsCaption");
          printf("    <img SRC='littledash.gif'>&nbsp;%s (%s)\n<br>", $deviceCaption, $lWOTcaption);
        }
        
	      if ($num_tests) // we've found tests that satisfy the test filter
		    {
          if (!$catPrint) // and if we have not already printed the category div
          {
            printf("%s", $oss);
            $catPrint = 1;  // do not print the category div twice
            $menuIndex++;
          }

          $oss = $oss . sprintf("        &nbsp;&nbsp;&nbsp;&nbsp;\n");
          printf("        <input type=checkbox name='%s' onclick='checkDeviceTests(%d,%d,%d)' value='1'>\n", $deviceName, $element, $num_tests, $menuIndex);
		      $element++;
          printf("        <span title='%s' onclick=swap('menu%d','image%d',%d)>\n", $deviceDescription, $menuIndex, $menuIndex, $menuIndex);
          printf("          <img SRC='littlex.gif' name='image%d'>&nbsp;%s\n", $menuIndex, $deviceCaption);
          printf("        </span>\n        <br>\n");
          printf("        <div id='menu%d' style='Visibility:hidden; display:none;'>\n", $menuIndex);		  

          $menuIndex++;
          for ($k=0; $k < $num_tests; $k++)
          {
	          $testNode = $tests->nodeset[$k];
            $testName = $testNode->get_attribute("name");
            $testCaption = $testNode->get_attribute("caption");
            $testDescription = $testNode->get_attribute("description");
            $requiresMedia = $testNode->get_attribute("requiresMedia");
            if ($requiresMedia)
              $ossmp = $ossmp . sprintf("mediaArray[mediaArray.length] = '%s';\n", $deviceCaption);

            printf("          &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n");
            printf("          <span title='%s' onclick=\"getParameters('%s','%s', 0);\">\n", $testDescription, $deviceName, $testName);
            printf("            <input type=checkbox name='%s-%s' id='%s' onclick=\"getParameters('%s','%s', %d);\">%s\n", $deviceName, $testName, $deviceCaption, $deviceName, $testName, $element, $testCaption);			
			      $element++;
            printf("          </span>\n          <br>\n");
	        } // end for tests
	        printf("        </div>\n");
		    } // end if num_tests
	    } // end for devices
      printf("      </div>\n");
	  } // end if num_devices
  }
?>
    </td>
  </tr>
</table>
</div>
<script language="Javascript">
var mediaArray = new Array();
<?php
  printf("%s", $ossmp);
?>
function expand_Collapse() 
{
  if(document.getElementById('expand_collapse').innerHTML == '<?php echo TR("MSG_EXPAND"); ?>')
  {
    document.getElementById('expand_collapse').innerHTML='<?php echo TR("MSG_COLLAPSE"); ?>';    
    for (i=0; i < <?php echo $menuIndex ?>; i++) 
    {
      document.getElementById('menu'+i).style.display = 'inline';
      document.getElementById('menu'+i).style.visibility = 'visible';
      document.images['image'+i].src = 'littledash.gif';
	    parent.parent.frames.headerFrame.testTree[i] = 'visible';
    }
  }
  else
  {
    document.getElementById('expand_collapse').innerHTML='<?php echo TR("MSG_EXPAND"); ?>';
    for (i=0; i < <?php echo $menuIndex ?>; i++) 
    {
      document.getElementById('menu'+i).style.display = 'none';
      document.getElementById('menu'+i).style.visibility = 'hidden';
      document.images['image'+i].src = 'littlex.gif';
	    parent.parent.frames.headerFrame.testTree[i] = 'hidden';
    }
  }
}

function growTrees(treeArray, select)
{
  if(parent.parent.frames.headerFrame.scheduledTest == "custom")
  {
    showScheduledMessage();
  }

  // expand the tree to it's last state
  var expanded=0;
  for (var i=0; i < <?php echo $menuIndex ?>; i++)
  {
	  if (treeArray[i] == "visible")
	  {
	    document.getElementById("menu"+i).style.display = 'inline';
      document.getElementById("menu"+i).style.visibility = 'visible';
      document.images["image"+i].src = 'littledash.gif';
	    expanded++;
	  }	    
  }

  if(expanded == <?php echo $menuIndex ?>)
    document.getElementById('expand_collapse').innerHTML='<?php echo TR("MSG_COLLAPSE"); ?>';

  // check tests that were previously left checked
  for (var j=4; j < document.diagRunForm.elements.length; j++)
  {
	  if (select[j] == "true")
	  {
	    document.diagRunForm.elements[j].checked = "true";
	  }
  }
}

function BeginTesting()
{
  //parent.parent.frames.dataFrame.frames.parmFrame.document.parametersForm.submit();
  
  testSelected = 'false';
  for (var i = 0; i < document.diagRunForm.elements.length; i++)
  {
    if (document.diagRunForm.elements[i].type == 'checkbox' && document.diagRunForm.elements[i].name != 'stopOnError')
	    if(document.diagRunForm.elements[i].checked == true)
      {
        testSelected = 'true';
		  //  Media prompt crap
        var lastPrompt;
        for (var arrIndex=0; arrIndex < mediaArray.length; arrIndex++) 
        {
          if ((mediaArray[arrIndex] == document.diagRunForm.elements[i].id) && (lastPrompt !=mediaArray[arrIndex]))
          {
            <?php printf("alert('%s ' +mediaArray[arrIndex]);\n", TR("MSG_PLEASE_INSERT_MEDIA")); ?> 
             lastPrompt = mediaArray[arrIndex];
          }
        }
      }
  }

  if(testSelected == 'true')
  {
    
	  document.diagRunForm.send.value="1";
    document.diagRunForm.submit();
  }
  else
   alert('<?php echo TR('MSG_PLEASE_SELECT_TEST'); ?>');
}
</script>
<input type=hidden name="send" value=0>
<input type=hidden name=device value="">
<input type=hidden name=test value="">
<input type='hidden' name='scheduleType' value='1'>
<input type='hidden' name='scheduleHour' value=''/>
<input type='hidden' name='scheduleMinute' value=''/>
<input type='hidden' name='scheduleMode' value=''/>
<input type='hidden' name='scheduleWeekdays' value=''/>
<input type='hidden' name='scheduleMonths' value=''/>
<input type='hidden' name='scheduleMonthdays' value=''/>
</form>
<script language='Javascript'>
if(parent.parent.frames.headerFrame.scheduledTest == "custom")
{
  showScheduledMessage();
}
</script>

<?php
}
?>
<script language="Javascript" src="norightclick.js"></script></body></html>
