<?php
session_start();

   /***********************************************************************
   *    Copyright  2002 - 2005 Hewlett-Packard Development Company, L.P. *
   ***********************************************************************/


$_SESSION["page"] = "surveymenu.php";
$_SESSION["statusDrawn"] = "false";
?>
<html>
<head>
  <meta http-equiv='content-type' content='text/html; charset=UTF-8'></meta>
  <title>HP Insight Diagnostics</title>
  <link rel='stylesheet' type='text/css' href='stylesheets/menu.css'>
  <link rel='stylesheet' type='text/css' href='stylesheets/main.css'>
  <style> body { background: 006699; } </style>
  <script language=Javascript src='menufunctions.js'></script>
</head>
<body onload="doMenuItem(parent.frames.globalFrame.currentCatItem);parent.frames.dataFrame.location=parent.frames.globalFrame.surveyView">
<form name="diagIDForm" method=POST>
<?php
//include "iocommand.php";
include "fefunctions.php";

if ($HTTP_POST_VARS["send"] == "1")
{
  $lang = GetLanguage();
  $result = loadTransArray($lang); // do front-end translations
  
  $idErrors = "";
  $idStatus = "";
  $idCommand = sprintf("<scheduleProcess hour='%s' minute='%s' mode='%s' weekdays='%s' months='%s' monthdays='%s'><diagID language='%s' surveyCapture='1'/></scheduleProcess>", $HTTP_POST_VARS["scheduleHour"], $HTTP_POST_VARS["scheduleMinute"], $HTTP_POST_VARS["scheduleMode"], $HTTP_POST_VARS["scheduleWeekdays"], $HTTP_POST_VARS["scheduleMonths"], $HTTP_POST_VARS["scheduleMonthdays"],$lang);
  ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $idCommand, $idStatus, $idErrors);
}

printf("<script language='Javascript'>\n");
printf("function changeViewLevel(level){\n");
printf("parent.frames.dataFrame.location=parent.frames.globalFrame.surveyView+'?surveyLevel=' + level;\n");
printf("}\n");                                                                  
printf("function changeSurveyView(cat)\n{\n");
printF("parent.frames.dataFrame.location=parent.frames.globalFrame.surveyView+'?category='+cat;\n");
printf("}</script>\n");
if ($_SESSION["idResult"]->is_blank_node)
  printf("NODE IS BLANK!");
else
{
  $idXml = new DomDocument($_SESSION["idResult"]);
  $idXpath = xpath_new_context($idXml->document_element());
  $categories = @xpath_eval($idXpath, "/diagOutput/category");  // get all the category objects
  printf("<fieldset><legend><b> %s </b></legend>\n", TR("MSG_VIEW"));
  printf("<table><tr><td>\n");																										
  printf("<font color=white>%s : <select name=level onchange=\"changeViewLevel(this.value);\">\n", TR("MSG_LEVEL"));
  printf("<option name=Summary value=Summary");
  if ($_SESSION["surveyLevel"] == "Summary" || $_SESSION["surveyLevel"] == "")
    printf(" selected");
  printf(">%s</option>\n", TR("MSG_SUMMARY"));
  printf("<option name=Advanced value=Advanced");
  if ($_SESSION["surveyLevel"] == "Advanced")
    printf(" selected");
  printf(">%s</option>\n", TR("MSG_ADVANCED"));
  printf("</select></td></tr></table></fieldset>\n");
  printf("<fieldset><legend><b> %s </b></legend><table>\n", TR("MSG_CATEGORIES"));
  printf("<tr><td><a id='item0' onClick='doMenuItem(0);changeSurveyView(\"All\");'"); //onClick='doMenuItem(0,\"survey.php?category=%s\")'", $catName);
  printf(" href=#> %s </a></td></tr>\n", TR("MSG_ALL"));
  //foreach(@$categories->nodeset as $cat)
  $num_cats = count($categories->nodeset);
  for($c=0; $c < $num_cats; $c++)
  {
    $cat = $categories->nodeset[$c];
    $depth = 0; // xml tree depth
    $catCaption = $cat->get_attribute("caption");
	  $catName = $cat->get_attribute("name");
	  printf("<tr><td><a id='item%d' onClick='doMenuItem(%d);changeSurveyView(\"%s\");'", $c+1, $c+1, $catName); //onClick='doMenuItem(0,\"survey.php?category=%s\")'", $catName);
	  printf(" href=# > %s  </a></td></tr>\n", $catCaption);
  }
  printf("</table>\n");
  printf("</fieldset>");
  if (IsOnline())
    printf("<br><br><center><table><tr><td><a href=# onclick='window.open(\"schedule.php?schedule=diagID\", \"scedule\", \"width=400,height=500,dependent=yes,directories=no,hotkeys=no,location=no,menubar=no,resizeable=no,status=no,toolbar=no,alwaysRaised=yes\");'><center><img src='cal.gif' border='0'>%s</a></td></tr></table>", TR("MSG_SCHEDULE_SURVEY_CAPTURE"));
}
?>
<input type='hidden' name='send' value='1'>
<input type='hidden' name='scheduleType' value='1'>
<input type='hidden' name='scheduleHour' value=''/>
<input type='hidden' name='scheduleMinute' value=''/>
<input type='hidden' name='scheduleMode' value=''/>
<input type='hidden' name='scheduleWeekdays' value=''/>
<input type='hidden' name='scheduleMonths' value=''/>
<input type='hidden' name='scheduleMonthdays' value=''/>

</form>
<script language="Javascript" src="norightclick.js"></script></body>
</html>
